<template src="./createInfoComponent.htm"></template>

<script>

    import Vue from 'vue';
    import FileComponent from '../../../../../inputs/FileComponent.vue';
    import ValidationErrorsMixin from '../../../../../mixins/validationErrorsMixin.js';

    Vue.component('file-component', FileComponent);

    export default {

        data() {

            return {

                baseInfo: {

                    name: '',

                    description: '',

                    logo: {

                        file: null,

                        preview: null
                    }
                }
            }
        },

        mixins: [ ValidationErrorsMixin ],

        methods: {

            /**
             * Assign processed file (image) to logo.
             */
            pushLogo(logo) {

                this.baseInfo.logo = logo;
            },


            /**
             * @param brand
             */
            createBrandStoreObject(brand) {

                return {

                    name: brand.name,

                    description: brand.description,

                    logo: brand.logo.file
                }
            }
        },

        watch: {

            /**
             * Push base info to store on each attribute change
             **/
            baseInfo: {

                handler(newBaseInfo) {

                    this.$store.dispatch('setBrand', this.createBrandStoreObject(newBaseInfo));
                },

                deep: true
            }
        }
    }

</script>